cordova.define("com.th.helmetPlugin", function (require, exports, module) {
    var exec = require('cordova/exec');
    module.exports = {
        /**
         *
           exec方法一共5个参数:
           第一个 :成功回调
           第二个 :失败回调
           第三个 :将要调用的对象名(在config.xml中配置,对应于feature的name属性，value就是本地实现的java类)
           第四个 :调用的方法名(java类中通过action识别方法名)
           第五个 :传递的参数（json格式）
         */
        invoke: function (action, jsonData, success, error) {
            cordova.exec(
            function (result) {  //成功
                if(success) success(result);
            },
            function (err) {//失败
                if(error) error(err);
            },
            'helmetPlugin',
            action,
            [jsonData]);
        }
    };
});
