cordova.define("cordova-plugin-audio-recorder-api.AudioRecorderAPI", function(require, exports, module) {
function AudioRecorderAPI() {
}

AudioRecorderAPI.prototype.record = function (successCallback, errorCallback, duration) {
  cordova.exec(successCallback, errorCallback, "AudioRecorderAPI", "record", duration ? [duration] : []);
};

AudioRecorderAPI.prototype.stop = function (successCallback, errorCallback) {
  cordova.exec(successCallback, errorCallback, "AudioRecorderAPI", "stop", []);
};

AudioRecorderAPI.prototype.playback = function (successCallback, errorCallback,path) {
  cordova.exec(successCallback, errorCallback, "AudioRecorderAPI", "playback", [path]);
};
AudioRecorderAPI.prototype.stopplay = function (successCallback, errorCallback) {
  cordova.exec(successCallback, errorCallback, "AudioRecorderAPI", "stopplay", []);
};
AudioRecorderAPI.prototype.decodeBase64 = function (successCallback, errorCallback,base64Code) {
  cordova.exec(successCallback, errorCallback, "AudioRecorderAPI", "decodeBase64", [base64Code]);
};
AudioRecorderAPI.prototype.decodeBytes = function (successCallback, errorCallback,bytesstr) {
  cordova.exec(successCallback, errorCallback, "AudioRecorderAPI", "decodeBytes", [bytesstr]);
};

AudioRecorderAPI.install = function () {
  if (!window.plugins) {
    window.plugins = {};
  }
  audioRecorderAPI = new AudioRecorderAPI();
  return audioRecorderAPI;
};

cordova.addConstructor(AudioRecorderAPI.install);

});
