cordova.define("com.cw.Rfid",function(require, exports, module) {

function Rfid(){}

Rfid.prototype.listenerConnectState = function (successCallback, errorCallback) {
  cordova.exec(successCallback, errorCallback, "Rfid", "listenerConnectState",  []);
};

Rfid.prototype.scanBluetooth = function (successCallback, errorCallback) {
  cordova.exec(successCallback, errorCallback, "Rfid", "scanBluetooth",  []);
};

Rfid.prototype.connectBluetooth = function (address, successCallback, errorCallback) {
  cordova.exec(successCallback, errorCallback, "Rfid", "connectBluetooth", [address]);
};

Rfid.prototype.disconnectBluetooth = function (successCallback, errorCallback) {
  cordova.exec(successCallback, errorCallback, "Rfid", "disconnectBluetooth", []);
};

Rfid.prototype.searchTag = function (successCallback, errorCallback) {
  cordova.exec(successCallback, errorCallback, "Rfid", "searchTag", []);
};

Rfid.prototype.getTags = function (successCallback, errorCallback) {
  cordova.exec(successCallback, errorCallback, "Rfid", "getTags", []);
};

Rfid.prototype.listenerReadTags = function (successCallback, errorCallback) {
  cordova.exec(successCallback, errorCallback, "Rfid", "listenerReadTags",  []);
};

Rfid.install = function () {
  if (!window.plugins) {
    window.plugins = {};
  }
  rfid = new Rfid();
  return rfid;
  };
  cordova.addConstructor(Rfid.install);
});