cordova.define('cordova/plugin_list', function(require, exports, module) {
module.exports = [
    {
        "id": "cordova-plugin-camera.Camera",
        "file": "plugins/cordova-plugin-camera/www/CameraConstants.js",
        "pluginId": "cordova-plugin-camera",
        "clobbers": [
            "Camera"
        ]
    },
    {
        "id": "cordova-plugin-camera.CameraPopoverOptions",
        "file": "plugins/cordova-plugin-camera/www/CameraPopoverOptions.js",
        "pluginId": "cordova-plugin-camera",
        "clobbers": [
            "CameraPopoverOptions"
        ]
    },
    {
        "id": "cordova-plugin-camera.camera",
        "file": "plugins/cordova-plugin-camera/www/Camera.js",
        "pluginId": "cordova-plugin-camera",
        "clobbers": [
            "navigator.camera"
        ]
    },
    {
        "id": "cordova-plugin-camera.CameraPopoverHandle",
        "file": "plugins/cordova-plugin-camera/www/CameraPopoverHandle.js",
        "pluginId": "cordova-plugin-camera",
        "clobbers": [
            "CameraPopoverHandle"
        ]
    },
    {
        "id": "cordova-plugin-device.device",
        "file": "plugins/cordova-plugin-device/www/device.js",
        "pluginId": "cordova-plugin-device",
        "clobbers": [
            "device"
        ]
    },
    {
        "id": "mx.ferreyra.callnumber.CallNumber",
        "file": "plugins/mx.ferreyra.callnumber/www/CallNumber.js",
        "pluginId": "mx.ferreyra.callnumber",
        "clobbers": [
            "call"
        ]
    },
    {
        "id": "cordova-plugin-local-notification.LocalNotification",
        "file": "plugins/cordova-plugin-local-notification/www/local-notification.js",
        "pluginId": "cordova-plugin-local-notification",
        "clobbers": [
            "cordova.plugins.notification.local",
            "plugin.notification.local"
        ]
    },
    {
        "id": "cordova-plugin-local-notification.LocalNotification.Core",
        "file": "plugins/cordova-plugin-local-notification/www/local-notification-core.js",
        "pluginId": "cordova-plugin-local-notification",
        "clobbers": [
            "cordova.plugins.notification.local.core",
            "plugin.notification.local.core"
        ]
    },
    {
        "id": "cordova-plugin-local-notification.LocalNotification.Util",
        "file": "plugins/cordova-plugin-local-notification/www/local-notification-util.js",
        "pluginId": "cordova-plugin-local-notification",
        "merges": [
            "cordova.plugins.notification.local.core",
            "plugin.notification.local.core"
        ]
    },
    {
        "id": "cordova-plugin-geolocation.geolocation",
        "file": "plugins/cordova-plugin-geolocation/www/android/geolocation.js",
        "pluginId": "cordova-plugin-geolocation",
        "clobbers": [
            "navigator.geolocation"
        ]
    },
    {
        "id": "cordova-plugin-geolocation.PositionError",
        "file": "plugins/cordova-plugin-geolocation/www/PositionError.js",
        "pluginId": "cordova-plugin-geolocation",
        "runs": true
    },
    {
        "id": "cordova-plugin-network-information.network",
        "file": "plugins/cordova-plugin-network-information/www/network.js",
        "pluginId": "cordova-plugin-network-information",
        "clobbers": [
            "navigator.connection",
            "navigator.network.connection"
        ]
    },
    {
        "id": "cordova-plugin-network-information.Connection",
        "file": "plugins/cordova-plugin-network-information/www/Connection.js",
        "pluginId": "cordova-plugin-network-information",
        "clobbers": [
            "Connection"
        ]
    },
    {
         "id": "cordova-plugin-sms.SMS",
         "file": "plugins/cordova-plugin-sms/www/SMS.js",
         "pluginId": "cordova-plugin-sms",
         "clobbers": [
             "window.SMS"
         ]
    },
    {
         "file": "plugins/cordova-plugin-th-msgpush/thmsgpush.js",  //导航插件js文件
         "id": "cordova-plugin-th-msgpush",  //插件id
         "merges": [
             "navigator.msgPush"  //调用名称
         ]
    },
    {
         "id":"cordova-plugin-xunfeiListenSpeaking",
         "file":"plugins/cordova-plugin-xunfeiListenSpeaking/cordova-plugin-xunfeiListenSpeaking.js",
         "clobbers":[
             "xunfeiListenSpeaking"
         ]
    },
    {
        "id": "cordova-plugin-fileopener.FileOpener",
        "file": "plugins/cordova-plugin-fileopener/www/FileOpener.js",
        "pluginId": "cordova-plugin-fileopener",
        "clobbers": [
            "cordova.plugins.FileOpener"
        ]
    },
    {
        "id": "cordova-plugin-audio-recorder-api.AudioRecorderAPI",
        "file": "plugins/cordova-plugin-audio-recorder-api/www/AudioRecorderAPI.js",
        "pluginId": "cordova-plugin-audio-recorder-api",
        "clobbers": [
            "audioRecorderAPI"
        ]
    },
    {
         "id": "cordova-plugin-mcamera.Mcamera",
         "file": "plugins/cordova-plugin-mcamera/www/mcamera.js",
         "pluginId": "cordova-plugin-mcamera",
         "clobbers": [
             "navigator.mcamera"
         ]
    },
    {
         "id": "cordova-plugin-mlocation.MLocation",
         "file": "plugins/cordova-plugin-mlocation/www/mlocation.js",
         "pluginId": "cordova-plugin-mlocation",
         "clobbers": [
             "navigator.mlocation"
         ]
    },
    {
          "id": "cordova-hot-code-push-plugin.chcp",
          "file": "plugins/cordova-hot-code-push-plugin/www/chcp.js",
          "pluginId": "cordova-hot-code-push-plugin",
          "clobbers": [
              "chcp"
          ]
    },
    {
             "file": "plugins/HUBUNavigationPlugin/navigate.js",  //导航插件js文件
             "id": "cn.edu.hubu.navigation",  //插件id
             "merges": [
                 "navigator.HUBUNavigate"  //调用名称
             ]
    },
    {
          "id": "cordova-plugin-file.DirectoryEntry",
          "file": "plugins/cordova-plugin-file/www/DirectoryEntry.js",
          "pluginId": "cordova-plugin-file",
          "clobbers": [
            "window.DirectoryEntry"
          ]
    },
    {
      "id": "cordova-plugin-file.DirectoryReader",
      "file": "plugins/cordova-plugin-file/www/DirectoryReader.js",
      "pluginId": "cordova-plugin-file",
      "clobbers": [
        "window.DirectoryReader"
      ]
    },
    {
      "id": "cordova-plugin-file.Entry",
      "file": "plugins/cordova-plugin-file/www/Entry.js",
      "pluginId": "cordova-plugin-file",
      "clobbers": [
        "window.Entry"
      ]
    },
    {
      "id": "cordova-plugin-file.File",
      "file": "plugins/cordova-plugin-file/www/File.js",
      "pluginId": "cordova-plugin-file",
      "clobbers": [
        "window.File"
      ]
    },
    {
      "id": "cordova-plugin-file.FileEntry",
      "file": "plugins/cordova-plugin-file/www/FileEntry.js",
      "pluginId": "cordova-plugin-file",
      "clobbers": [
        "window.FileEntry"
      ]
    },
    {
      "id": "cordova-plugin-file.FileError",
      "file": "plugins/cordova-plugin-file/www/FileError.js",
      "pluginId": "cordova-plugin-file",
      "clobbers": [
        "window.FileError"
      ]
    },
    {
      "id": "cordova-plugin-file.FileReader",
      "file": "plugins/cordova-plugin-file/www/FileReader.js",
      "pluginId": "cordova-plugin-file",
      "clobbers": [
        "window.FileReader"
      ]
    },
    {
      "id": "cordova-plugin-file.FileSystem",
      "file": "plugins/cordova-plugin-file/www/FileSystem.js",
      "pluginId": "cordova-plugin-file",
      "clobbers": [
        "window.FileSystem"
      ]
    },
    {
      "id": "cordova-plugin-file.FileUploadOptions",
      "file": "plugins/cordova-plugin-file/www/FileUploadOptions.js",
      "pluginId": "cordova-plugin-file",
      "clobbers": [
        "window.FileUploadOptions"
      ]
    },
    {
      "id": "cordova-plugin-file.FileUploadResult",
      "file": "plugins/cordova-plugin-file/www/FileUploadResult.js",
      "pluginId": "cordova-plugin-file",
      "clobbers": [
        "window.FileUploadResult"
      ]
    },
    {
      "id": "cordova-plugin-file.FileWriter",
      "file": "plugins/cordova-plugin-file/www/FileWriter.js",
      "pluginId": "cordova-plugin-file",
      "clobbers": [
        "window.FileWriter"
      ]
    },
    {
      "id": "cordova-plugin-file.Flags",
      "file": "plugins/cordova-plugin-file/www/Flags.js",
      "pluginId": "cordova-plugin-file",
      "clobbers": [
        "window.Flags"
      ]
    },
    {
      "id": "cordova-plugin-file.LocalFileSystem",
      "file": "plugins/cordova-plugin-file/www/LocalFileSystem.js",
      "pluginId": "cordova-plugin-file",
      "clobbers": [
        "window.LocalFileSystem"
      ],
      "merges": [
        "window"
      ]
    },
    {
      "id": "cordova-plugin-file.Metadata",
      "file": "plugins/cordova-plugin-file/www/Metadata.js",
      "pluginId": "cordova-plugin-file",
      "clobbers": [
        "window.Metadata"
      ]
    },
    {
      "id": "cordova-plugin-file.ProgressEvent",
      "file": "plugins/cordova-plugin-file/www/ProgressEvent.js",
      "pluginId": "cordova-plugin-file",
      "clobbers": [
        "window.ProgressEvent"
      ]
    },
    {
      "id": "cordova-plugin-file.fileSystems",
      "file": "plugins/cordova-plugin-file/www/fileSystems.js",
      "pluginId": "cordova-plugin-file"
    },
    {
      "id": "cordova-plugin-file.requestFileSystem",
      "file": "plugins/cordova-plugin-file/www/requestFileSystem.js",
      "pluginId": "cordova-plugin-file",
      "clobbers": [
        "window.requestFileSystem"
      ]
    },
    {
      "id": "cordova-plugin-file.resolveLocalFileSystemURI",
      "file": "plugins/cordova-plugin-file/www/resolveLocalFileSystemURI.js",
      "pluginId": "cordova-plugin-file",
      "merges": [
        "window"
      ]
    },
    {
      "id": "cordova-plugin-file.isChrome",
      "file": "plugins/cordova-plugin-file/www/browser/isChrome.js",
      "pluginId": "cordova-plugin-file",
      "runs": true
    },
    {
      "id": "cordova-plugin-file.androidFileSystem",
      "file": "plugins/cordova-plugin-file/www/android/FileSystem.js",
      "pluginId": "cordova-plugin-file",
      "merges": [
        "FileSystem"
      ]
    },
    {
      "id": "cordova-plugin-file.fileSystems-roots",
      "file": "plugins/cordova-plugin-file/www/fileSystems-roots.js",
      "pluginId": "cordova-plugin-file",
      "runs": true
    },
    {
      "id": "cordova-plugin-file.fileSystemPaths",
      "file": "plugins/cordova-plugin-file/www/fileSystemPaths.js",
      "pluginId": "cordova-plugin-file",
      "merges": [
        "cordova"
      ],
      "runs": true
    },
    {
      "id": "cordova-plugin-media-capture.CaptureAudioOptions",
      "file": "plugins/cordova-plugin-media-capture/www/CaptureAudioOptions.js",
      "pluginId": "cordova-plugin-media-capture",
      "clobbers": [
        "CaptureAudioOptions"
      ]
    },
    {
      "id": "cordova-plugin-media-capture.CaptureImageOptions",
      "file": "plugins/cordova-plugin-media-capture/www/CaptureImageOptions.js",
      "pluginId": "cordova-plugin-media-capture",
      "clobbers": [
        "CaptureImageOptions"
      ]
    },
    {
      "id": "cordova-plugin-media-capture.CaptureVideoOptions",
      "file": "plugins/cordova-plugin-media-capture/www/CaptureVideoOptions.js",
      "pluginId": "cordova-plugin-media-capture",
      "clobbers": [
        "CaptureVideoOptions"
      ]
    },
    {
      "id": "cordova-plugin-media-capture.CaptureError",
      "file": "plugins/cordova-plugin-media-capture/www/CaptureError.js",
      "pluginId": "cordova-plugin-media-capture",
      "clobbers": [
        "CaptureError"
      ]
    },
    {
      "id": "cordova-plugin-media-capture.MediaFileData",
      "file": "plugins/cordova-plugin-media-capture/www/MediaFileData.js",
      "pluginId": "cordova-plugin-media-capture",
      "clobbers": [
        "MediaFileData"
      ]
    },
    {
      "id": "cordova-plugin-media-capture.MediaFile",
      "file": "plugins/cordova-plugin-media-capture/www/MediaFile.js",
      "pluginId": "cordova-plugin-media-capture",
      "clobbers": [
        "MediaFile"
      ]
    },
    {
      "id": "cordova-plugin-media-capture.helpers",
      "file": "plugins/cordova-plugin-media-capture/www/helpers.js",
      "pluginId": "cordova-plugin-media-capture",
      "runs": true
    },
    {
      "id": "cordova-plugin-media-capture.capture",
      "file": "plugins/cordova-plugin-media-capture/www/capture.js",
      "pluginId": "cordova-plugin-media-capture",
      "clobbers": [
        "navigator.device.capture"
      ]
    },
    {
      "id": "cordova-plugin-media-capture.init",
      "file": "plugins/cordova-plugin-media-capture/www/android/init.js",
      "pluginId": "cordova-plugin-media-capture",
      "runs": true
    },
    {
      "id": "cordova-plugin-barcodescanner.BarcodeScanner",
      "file": "plugins/cordova-plugin-barcodescanner/www/barcodescanner.js",
      "pluginId": "cordova-plugin-barcodescanner",
      "clobbers": [
        "cordova.plugins.barcodeScanner"
      ]
    },
    {
      "file":"plugins/callphonerecoder/callphonerecorder.js",  //导航插件js文件
      "id":"com.th.CallRecoder",  //插件id
      "clobbers": [
          "callRecoder"  //调用名称
      ]
    },
    {
       "file":"plugins/iscptools/iscp.js",  //导航插件js文件
      "id":"com.th.IscpTools",  //插件id
      "clobbers": [
          "iscpTools"  //调用名称
      ]
    },
    {
      "file":"plugins/ocrplugin/ocr.js",  //导航插件js文件
      "id":"com.th.Ocr",  //插件id
      "runs": true,
      "clobbers": [
          "ocr"  //调用名称
      ]
    },
    {
      "file":"plugins/mipplugin/mipplugin.js",  //导航插件js文件
      "id":"com.th.MipPlugin",  //插件id
      "runs": true,
      "clobbers": [
          "mipPlugin"  //调用名称
      ]
     },
     {
        "file":"plugins/cw-rfid/rfid.js",
        "id":"com.cw.Rfid",
        "clobbers": [
            "rfid"
        ]
      },
      {
        "file":"plugins/uhf-bt/uhfbt.js",
        "id":"com.uhf.uhfbt",
        "clobbers": [
            "uhfbt"
        ]
     },
     {
        "file":"plugins/network/network.js",
        "id":"com.th.network",
        "clobbers": [
            "network"
        ]
     },
     {
         "file":"plugins/database/database.js",
         "id":"com.th.database",
         "clobbers": [
             "database"
         ]
      },{
         "file":"plugins/localStorge/localStorge.js",
         "id":"com.th.plugins.LocalStorge",
         "clobbers": [
             "mLocalStorge"
         ]
       },{
		   "file":"plugins/zxRfid/rfid.js",
		   "id":"com.th.plugins.zxRfid",
		   "clobbers": [
			   "mzxRfid"
		   ]
		},{
           "file":"plugins/softKeyBoard/softKeyBoard.js",
           "id":"com.th.plugins.SoftKeyBoard",
           "clobbers": [
               "mSoftKeyBoard"
           ]
      },
      {
          "id": "cordova-plugin-mupdate.MUpdate",
          "file": "plugins/cordova-plugin-update/www/mupdate.js",
          "pluginId": "cordova-plugin-mupdate",
          "clobbers": [
              "navigator.mupdate"
          ]
       },
      {
         "file":"plugins/webviewplugin/webActivity.js",
         "id":"com.th.WebActivity",  //插件id
         "runs": true,
         "clobbers": [
             "webActivity"  //调用名称
         ]
     },
     {
         "id": "cordova-plugin-inappbrowser.inappbrowser",
         "file": "plugins/cordova-plugin-inappbrowser/www/inappbrowser.js",
         "pluginId": "cordova-plugin-inappbrowser",
         "clobbers": [
             "cordova.InAppBrowser.open",
             "window.open"
         ]
     },
      {
          "file": "plugins/cordova-plugin-mdownload/mdownload.js",
          "id": "cordova-plugin-mdownload",
          "clobbers": [
              "window.mdownload"
          ]
      },
      {
         "id": "th-plugin-officepreview",
         "file": "plugins/com-th-plugin-officepreview/officepreview.js",
         "clobbers": [
             "window.officepreview"
         ]
      },
     {
        "id": "th-plugin-fileupload",
        "file": "plugins/com-th-plugin-fileupload/fileupload.js",
        "clobbers": [
            "window.ThFileUpload"
        ]
     },
    {
       "file":"plugins/rtcplugin/rtc.js",
       "id":"com.th.rtc",  //插件id
       "clobbers": [
           "rtc"  //调用名称
       ]
     },
      {
            "file":"plugins/threfresh-plugin/threfresh.js",
            "id":"com.th.threfresh",  //插件id
            "clobbers": [
                "threfresh"  //调用名称
            ]
       },
      {
               "id": "cordova-plugin-mface.MFace",
                           "file": "plugins/cordova-plugin-face/www/mface.js",
                           "pluginId": "cordova-plugin-mface",
                           "clobbers": [
                               "navigator.mface"
                           ]
             },

     {
       "id": "tellhow-plugin-customkeyboard",
       "file": "plugins/tellhow-plugin-customkeyboard/www/CustomKeyboard.js",
       "clobbers": [
         "customKeyboard"
       ]
     },
     {
         "file": "plugins/facerecon/facerecon.js",
         "id": "com.th.FaceRecon",
         "clobbers": [
             "faceRecon"
         ]
     },
      {
         "file":"plugins/com-th-plugin-common/common.js",
         "id":"com.th.commonPlugin",  //插件id
         "clobbers": [
             "commonPlugin"  //调用名称
         ]
       },
       {
            "file":"plugins/com-th-plugin-selfdatabase/selfdatabase.js",
            "id":"com.th.selfDataBasePlugin",  //插件id
            "clobbers": [
                "wx"  //调用名称
            ]
        },{
        "file":"plugins/com-th-plugin-helmet/helmet.js",
        "id":"com.th.helmetPlugin",  //插件id
        "clobbers": [
            "helmetPlugin"  //调用名称
        ]
      },
       {
        "id": "tellhow-plugin-officepreview.OfficePreview",
        "file": "plugins/tellhow-plugin-officepreview/www/OfficePreview.js",
        "pluginId": "tellhow-plugin-officepreview",
        "clobbers": [
          "tellhow.OfficePreview"
        ]
      }
];
module.exports.metadata = 
// TOP OF METADATA
{
    "cordova-plugin-whitelist": "1.3.2",
    "cordova-plugin-compat": "1.1.0",
    "cordova-plugin-camera": "2.4.1",
    "cordova-plugin-device": "1.1.6",
    "mx.ferreyra.callnumber": "0.0.2",
    "cordova-plugin-app-event": "1.2.0",
    "cordova-plugin-local-notification": "0.8.4",
    "cordova-plugin-geolocation": "2.4.3",
    "cordova-plugin-network-information": "1.3.3",
    "cordova-plugin-sms": "1.0.5",
    "cordova-plugin-fileopener": "1.0.5",
    "cordova-plugin-audio-recorder-api": "0.0.1",
    "cordova-hot-code-push-plugin": "1.5.3",
    "cordova-plugin-whitelist": "1.3.3",
    "cordova-plugin-file": "5.0.0",
    "cordova-plugin-media-capture": "2.0.0",
    "cordova-plugin-barcodescanner": "0.7.1",
    "tellhow-plugin-officepreview": "1.0.0"
};
// BOTTOM OF METADATA
});