cordova.define("cordova-plugin-mupdate.MUpdate", function(require, exports, module) {
/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
*/
    var exec = require('cordova/exec');
    module.exports = {
        /**
         *
           exec方法一共5个参数:
           第一个 :成功回调
           第二个 :失败回调
           第三个 :将要调用的对象名(在config.xml中配置,对应于feature的name属性，value就是本地实现的java类)
           第四个 :调用的方法名(java类中通过action识别方法名)
           第五个 :传递的参数（json格式）
         */
        mUpdate: function(action,obj,success,error) {
            var arr = [];
            cordova.exec(
            function(result){
                    //成功后的回调，这里仅仅弹出了返回参数。
                success(result);
            },
            function(err) {
               //失败后的回调，可以弹出失败原因。
               error(err);
            },
            "mUpdate",action,[obj]);
        }
    };
});
