cordova.define("com.th.plugins.LocalStorge",function(require, exports, module) {

function LocalStorge(){}

LocalStorge.prototype.setItem = function (successCallback, errorCallback, options) {
  var key = options.key;
  var value = options.value;
  var args = [key, value];
  cordova.exec(successCallback, errorCallback, "LocalStorge", "setItem", args);
};
LocalStorge.prototype.getItem = function (successCallback, errorCallback, key) {
  var args = [key];
  cordova.exec(successCallback, errorCallback, "LocalStorge", "getItem", args);
};
LocalStorge.prototype.removeItem = function (successCallback, errorCallback, key) {
  var args = [key];
  cordova.exec(successCallback, errorCallback, "LocalStorge", "removeItem", args);
};
LocalStorge.install = function () {
  if (!window.plugins) {
    window.plugins = {};
  }
  mLocalStorge = new LocalStorge();
  return mLocalStorge;
  };
  cordova.addConstructor(LocalStorge.install);
});