cordova.define("com.th.WebActivity",function(require, exports, module) {

function WebActivity(){
}
WebActivity.prototype.openApp = function (url,title, titleColor, successCallback, errorCallback) {
  cordova.exec(successCallback, errorCallback, "WebActivity", "openApp",  [url,title, titleColor]);
};

WebActivity.prototype.openSgccSDK = function (userId,userName,orgId,unitId,teamId,teamName,successCallback, errorCallback) {
  cordova.exec(successCallback, errorCallback, "WebActivity", "openSgccSDK", [userId,userName,orgId,unitId,teamId,teamName]);
};

WebActivity.prototype.openSgccScan = function (userId,userName,orgId,unitId,teamId,teamName,successCallback, errorCallback) {
  cordova.exec(successCallback, errorCallback, "WebActivity", "openSgccScan", [userId,userName,orgId,unitId,teamId,teamName]);
};

WebActivity.prototype.openLnSgccScan = function (userId,userName,orgId,unitId,teamId,teamName,successCallback, errorCallback) {
  cordova.exec(successCallback, errorCallback, "WebActivity", "openLnSgccScan", [userId,userName,orgId,unitId,teamId,teamName]);
};

WebActivity.prototype.setLoginInfo = function (logininfo,successCallback, errorCallback) {
  cordova.exec(successCallback, errorCallback, "WebActivity", "setLoginInfo",  [logininfo]);
};

WebActivity.prototype.getLoginInfo = function (successCallback, errorCallback) {
  cordova.exec(successCallback, errorCallback, "WebActivity", "getLoginInfo",  []);
};

WebActivity.prototype.setMicroTitle = function(title, successCallback, errorCallback){
    cordova.exec(successCallback, errorCallback, "WebActivity", "setMicroTitle",[title]);
};

WebActivity.prototype.setClickHistoryGoBack = function(successCallback, errorCallback){
    cordova.exec(successCallback, errorCallback, "WebActivity", "setClickHistoryGoBack",  []);
};

WebActivity.prototype.closeMicroApp = function(successCallback, errorCallback){
    cordova.exec(successCallback, errorCallback, "WebActivity", "closeMicroApp",  []);
};

WebActivity.prototype.setCommonMicroTitleStyle = function(successCallback, errorCallback){
    cordova.exec(successCallback, errorCallback, "WebActivity", "setCommonMicroTitleStyle", []);
};


WebActivity.install = function () {
  if (!window.plugins) {
    window.plugins = {};
  }
  webActivity = new WebActivity();
  return webActivity;
};

cordova.addConstructor(WebActivity.install);
});
